;$Id: pcinstall.iss 1772 2001-08-19 07:00:08Z andy $
;this builds the setup program for people to download.

;to build Windows distributions for PageCatcher, you
;need to download and install Inno Setp Compiler 2.0.13
;from www.innosetup.com.

; this script assumes a 'standard' Python installation
; with needed pyds in C:\Python21\DLLs.  If your distro
; is different, copy this to e.g. pcinstall_fred.iss
; and run there, rather than an endless cycle of committing
; different people's installer scripts.

;procedure:
;1. use freeze to make a pageCatcher.exe.  AARON - document
; this step here please!
;2. open this file (double click will do) and hit F9 to
; compile.  It will put the setup program in
; the Output subdirectory.
;3. test test test then  put the setup program on the web site.



[Setup]
OutputBaseFilename=PageCatcherSetup-1.2
AppName=PageCatcher
AppVerName=PageCatcher 1.2
AppPublisher=ReportLab Inc.
AppPublisherURL=http://www.reportlab.com/
AppSupportURL=http://www.reportlab.com/
AppUpdatesURL=http://www.reportlab.com/
DefaultDirName={pf}\ReportLab\PageCatcher
DefaultGroupName=ReportLab
AlwaysCreateUninstallIcon=yes
LicenseFile=license.txt
InfoBeforeFile=00README.txt
; uncomment the following line if you want your installation to run on NT 3.51 too.
; MinVersion=4,3.51
WizardImageFile=replogo.bmp
WizardImageBackColor=$88564e
;; inno uses bbggrr instead of rrggbb, devious chaps.  We use $4e5688

[Tasks]
;Name: "desktopicon"; Description: "Create a &desktop icon"; GroupDescription: "Additional icons:"; MinVersion: 4,4

[Files]

Source: "pageCatcher.exe"; DestDir: "{app}"; CopyMode: alwaysoverwrite

;docco
Source: "00README.txt"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "PageCatchIntro.html"; DestDir: "{app}"; CopyMode: alwaysoverwrite

;all dependent DLLs.  Try to slim down to absolute minimum!
Source: "C:\winnt\system32\python21.dll"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "C:\Python21\DLLs\_imaging.pyd"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "C:\Python21\DLLs\_rl_accel.pyd"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "C:\Python21\DLLs\_sre.pyd"; DestDir: "{app}"; CopyMode: alwaysoverwrite
Source: "C:\Python21\DLLs\zlib.pyd"; DestDir: "{app}"; CopyMode: alwaysoverwrite

;all demo stuff
Source: "demos\runall.bat"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\sample1.pdf"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\sample2.pdf"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\sample3.pdf"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\example1_fillform.py"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\example2_reverse.py"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\example3_append.py"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\example4_fourpage.py"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\example5_background.py"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\example6_twopage.py"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite
Source: "demos\example7_split.py"; DestDir: "{app}\demos"; CopyMode: alwaysoverwrite

[INI]
Filename: "{app}\pageCatcher.url"; Section: "InternetShortcut"; Key: "URL"; String: "http://www.reportlab.com/"

[Icons]
Name: "{group}\PageCatcher"; Filename: "{app}\pageCatcher.exe"
Name: "{group}\PageCatcher on the Web"; Filename: "{app}\pageCatcher.url"
;Name: "{userdesktop}\PageCatcher"; Filename: "{app}\pageCatcher.exe"; MinVersion: 4,4; Tasks: desktopicon

[UninstallDelete]
Type: files; Name: "{app}\pageCatcher.url"

